Summary: GNU libc
name: glibc
Version: 2.0.5c
%define kheaders 2.1.60
Release: 10
Copyright: LGPL
Group: Development/Libraries/Libc
Source0: ftp://prep.ai.mit.edu:/pub/gnu/glibc-2.0.5.tar.gz
Source1: ftp://prep.ai.mit.edu:/pub/gnu/glibc-localedata-2.0.5.tar.gz
Source2: ftp://prep.ai.mit.edu:/pub/gnu/glibc-linuxthreads-2.0.5.tar.gz
Source3: ftp://prep.ai.mit.edu:/pub/gnu/glibc-crypt-2.0.5.tar.gz
Source4: nsswitch.conf
Source5: ftp://ftp.kernel.org/pub/linux/kernel/v2.1/linux-%{kheaders}.tar.gz
Source6: glibc-2.0.5-glob.c
Patch1: ftp://prep.ai.mit.edu:/pub/gnu/glibc-2.0.5-2.0.5c.diff.gz
Patch2: glibc-2.0.5c-rcmd.patch
Patch3: glibc-2.0.x-memleak.patch
Patch4: glibc-2.0.5-ldso.patch
Patch5: glibc-2.0.5-scmrights.patch
Patch6: glibc-2.0.5-mblen.patch
Patch7: glibc-2.0.5-timezone.patch
Patch8: glibc-2.0.5-writev.patch
Patch9: glibc-2.0.5c-setlocale.patch
BuildRoot: /var/tmp/glibcroot
Obsoletes: zoneinfo libc-static libc-devel libc-profile libc-headers
%ifarch alpha
Provides: ld.so.1
%else
Provides: ld.so.2
%endif

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a
Linux system will not function. It also contains national language (locale)
support and timezone databases.

%package debug
Summary: glibc with debugging information
Group: Development/Libraries/Libc

%description debug
These libraries have the debugging information debuggers use for tracing
the execution of programs. These are only needed when the shared libraries
themselves are being debugged -- they are not needed to debug programs which
use them.

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries/Libc
Requires: kernel-headers
Prereq: /sbin/install-info
Obsoletes: libc-devel

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%package profile
Summary: glibc with profiling support
Group: Development/Libraries/Libc
Obsoletes: libc-profile

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%prep 
%setup -q -a 1 -a 2 -a 3 -n glibc-2.0.5
%patch1 -p0
(cd nss;
%patch2 -p0
)
%patch3 -p1

(cd sysdeps/generic;
%patch4 -p1
)

%patch5 -p1

(cd stdlib;
%patch6 -p0
)

(cd time;
%patch7 -p0
)

(cd sysdeps/posix;
%patch8 -p0
)

(cd locale;
%patch9 -p0
)

rm ./posix/glob.c
cp $RPM_SOURCE_DIR/glibc-2.0.5-glob.c ./posix/glob.c

find . -type f -name "*.orig" | xargs rm -rf 
find . -type f -empty | xargs rm -rf 
find . -type d -name "CVS" | xargs rm -rf

echo 'pthread/cmpxchg' > linuxthreads/sysdeps/alpha/Implies

tar xzf $RPM_SOURCE_DIR/linux-%{kheaders}.tar.gz linux/include
ln -s asm-${RPM_ARCH} linux/include/asm
ln -s ../../../../linux/include/linux sysdeps/unix/sysv/linux/linux
ln -s ../../../../linux/include/asm sysdeps/unix/sysv/linux/asm

%build
CFLAGS="$RPM_OPT_FLAGS -g -DNDEBUG=1" ./configure --enable-add-ons=crypt,linuxthreads,localedata --enable-profile --prefix=/usr

make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

make install_root=$RPM_BUILD_ROOT install

gzip -9nvf $RPM_BUILD_ROOT/usr/info/libc*

rm -rf $RPM_BUILD_ROOT/usr/share/zoneinfo/{localtime,posixtime,posixrules}
ln -sf ../../../etc/localtime $RPM_BUILD_ROOT/usr/share/zoneinfo/localtime
ln -sf localtime $RPM_BUILD_ROOT/usr/share/zoneinfo/posixtime
ln -sf localtime $RPM_BUILD_ROOT/usr/share/zoneinfo/posixrules
ln -sf ../../usr/lib/libbsd-compat.a $RPM_BUILD_ROOT/usr/lib/libbsd.a
rm -f $RPM_BUILD_ROOT/etc/localtime

cp $RPM_SOURCE_DIR/nsswitch.conf $RPM_BUILD_ROOT/etc/nsswitch.conf

find $RPM_BUILD_ROOT -type f -or -type l | 
	sed 's|.*/etc|%config &|' > rpm.filelist.in
for n in /usr/share/zoneinfo /usr/share/i18n/charmaps /usr/include; do 
    find ${RPM_BUILD_ROOT}${n} -type d | sed "s/^/%dir /" >> rpm.filelist.in
done

# primary filelist
sed "s|$RPM_BUILD_ROOT||" < rpm.filelist.in | 
	grep -v '/usr/lib/libg.a' | sort > rpm.filelist

grep '/usr/lib/lib.*_p\.a' < rpm.filelist > profile.filelist
egrep "(/usr/include)|(/usr/info)" < rpm.filelist | 
	grep -v /usr/info/dir > devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*_p.a' rpm.filelist.full | 
	egrep -v "(/usr/include)|(/usr/info)" > rpm.filelist

grep '/usr/lib/lib.*\.a' < rpm.filelist >> devel.filelist
grep '/usr/lib/.*\.o' < rpm.filelist >> devel.filelist
grep '/usr/lib/.*\.so' < rpm.filelist >> devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*\.a' < rpm.filelist.full |
	grep -v '/usr/lib/.*\.o' |
	grep -v '/usr/lib/.*\.so' > rpm.filelist

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post devel
/sbin/install-info /usr/info/libc.info.gz /usr/info/dir

%preun devel
if [ "$1" = 0 ]; then
    /sbin/install-info --delete /usr/info/libc.info.gz /usr/info/dir
fi

%clean
rm -rf "$RPM_BUILD_ROOT"

%changelog

* Sun Nov 09 1997 Erik Troan <ewt@redhat.com>

- added setlocale patch from Ulrich

* Wed Nov 05 1997 Erik Troan <ewt@redhat.com>

- added new glob.c from Ulrich

* Wed Oct 29 1997 Erik Troan <ewt@redhat.com>

- fixed timezone patch

* Tue Oct 28 1997 Erik Troan <ewt@redhat.com>

- added patch to fix sense on timezone global

* Sat Oct 25 1997 Erik Troan <ewt@redhat.com>

- build against included kernel headers
- added ld.so patch from ulrich

* Fri Oct 24 1997 Erik Troan <ewt@redhat.com>

- added documentation files as %doc
- improved obsoletes list

* Thu Oct 16 1997 Erik Troan <ewt@redhat.com>

- added patch to fix nfs inet_ntoa() memory leak
- create proper sysdeps/alpha/Implies
- create configparms w/ a here doc, not a separate patch file

* Thu Oct 09 1997 Erik Troan <ewt@redhat.com>

- added patch from Ulrich for rcmd() w/ IP number

* Tue Sep 16 1997 Erik Troan <ewt@redhat.com>

- added obsolete entries 

* Mon Sep 15 1997 Erik Troan <ewt@redhat.com>

- removed /usr/info/dir
- added support for install-info for devel package

* Wed Sep 10 1997 Erik Troan <ewt@redhat.com>

- updated to 2.0.5c

* Wed Sep 10 1997 Erik Troan <ewt@redhat.com>

- added getcwd() fix from Ulrich
- changed datadir to default /usr/share instead of /usr/lib

* Mon Sep 01 1997 Erik Troan <ewt@redhat.com>

- fixed some symlinks (which broke due to the buildroot)

* Thu Aug 28 1997 Erik Troan <ewt@redhat.com>

- removed extrneous symlinks invocation
- removed /etc/localtime from filelist

* Wed Aug 27 1997 Erik Troan <ewt@redhat.com>

- added patch to tcp.h from Ulrich

* Wed Aug 27 1997 Erik Troan <ewt@redhat.com>

- updated to 2.0.5
- removed zic symlink hack

* Sat Aug 23 1997 Erik Troan <ewt@redhat.com>

- minor hack for alpha (won't be necessary in next release)
- switched to use a build root
- dynamically builds file lists

* Tue Aug 19 1997 Erik Troan <ewt@redhat.com>

1) Updated to glibc 2.0.5pre5 (version of package is 2.0.4.9)

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>

1) Updated to glibc 2.0.4

* Thu May 15 1997 Erik Troan <ewt@redhat.com>

1) Updated to glibc 2.0.3, builds glibc on Intel as well.

* Tue Feb 18 1997 Erik Troan <ewt@redhat.com>

1) added patch for shadow to work w/ :: rather then :-1: entries
2) incorporated Richard Henderson's string operation fix
3) added default /etc/nsswitch.conf

%files -f rpm.filelist
%doc README NEWS INSTALL FAQ BUGS NOTES PROJECTS

%files devel -f devel.filelist

%files profile -f profile.filelist

%files debug
/usr/lib/libg.a
